#ifndef UNDER_CE
#include <stdio.h>
#endif

#include <stdlib.h>
#include <string.h>

#include "lex.h"
#include "parse.h"
#include "code.h"
#include "stack.h"
#include "bc2_ex.h"
#include "variable.h"
#include "machine.h"

extern int def_function;

#if UNDER_CE > 200
int errno;
#endif



/* 
 */
void bc2_init(void)
{
	struct stack_s s;

#ifdef WINDOWS
/* for 80 bit floting number*/
	__asm("fninit");
#endif

	s.type=TYPE_FLOAT;
#ifdef USE_LONG_DOUBLE
	s.num.f=3.141592653589793238462643383279502884L;
#else
	s.num.f=3.141592653589793238462643383279502884;
#endif

	variable_set("pi", &s);
}

/*
 * mۂB
 *
 * ĂяoƂẮA
 *   bc2_init();
 *       :
 *    bc2_calc_string(...);
 *       :
 *   bc2_free();
 *
 * ƂȂ邪Abc2_calc_string() ̌Ăяo񂠂ꍇɂ́A
 * bc2_init(), bc2_free() ĂяoKv͂ȂB
 *
 * ܂Abc2_calc_string() wĂяoƂȂxƂ bc2_free() 
 * s΂悢B
 *
 */
#if 0
void bc2_free(void)
{
	free(stack_memory);
	free(code);

/* ȂĂAtFCZ[t */
	stack_memory=NULL;
	code=NULL;
}
#endif
/* W[̃C̊֐
 * ȑOɔׂāA^A^ƌvZʂ̌^ႤBres  type QƂ̂
 */
int bc2_calc_string(char * const str, char ** const end, struct bc_s * const res)
{
	char *p_end;

	error=0;

#ifdef WINDOWS
/* for 80 bit */
	__asm("fninit");
#endif

/* init */
	init_stack();
	init_code();
	lex_init(str);

/*  & ԃR[h쐬 */
	expression();

	*end=lex_get_lex_begin();
	if(**end && error == 0)
		error=ER_UNACCEPTED_CHARACTER;

	if(error != 0)
	{
		free_code();
		return error;
	}

	p_end=run_code();
	free_code();

	if(error)
		*end=p_end;
	else if(def_function == 1)
		res->type=TYPE_FUNCTION;
	else
	{
		struct stack_s *p;

		p=pop();
		if(p)
			memcpy(res, p, sizeof(struct bc_s));
	}

	return error;
}



