
#ifndef UNDER_CE
#include <stdio.h>
#include <errno.h>
#endif


#include <stdlib.h>
#include <math.h>

#include "code.h"
#include "user_func.h"
#include "lex.h"
#include "stack.h"
#include "parse.h"
#include "buildin_function.h"

static int call_function_sub(struct user_function_s * const p);

static int stack_frame;
static int parameter_count;

#define MAX_PARAMETER 2	/* rhC֐̍ő̈ */


/* return num of parameter */
int check_parameter_number(char * const name)
{
	struct user_function_s *p;
	struct buildin_function_s *q;

	p=check_user_function(name);
	if(p != NULL)
		return p->parameter_count;

	q=check_build_in_function(name);
	if(q != NULL)
		return q->parameter_count;

	return 0;
}


/* ֐̌Ăяo
 * return
 *  0:success
 *  1:failur
 */
int call_function(char * const name)
{
	struct user_function_s *p;

	p=check_user_function(name);
	if(p == NULL)
	{
		struct buildin_function_s *q;
		struct stack_s *s[MAX_PARAMETER];
		int i;

		q=check_build_in_function(name);
		if(q == NULL)
			return 1;

		for(i=q->parameter_count-1; i > 0; i--)
		{
			s[i]=pop();
			if(s[i]->type == TYPE_INTEGER)
				conv_integer_to_float(s[i]);
		}
		s[0]=virtual_pop();
		if(s[0]->type == TYPE_INTEGER)
			conv_integer_to_float(s[0]);

/* f(s0, s1, s2, ...)
 * ƁAɈƁAYv
 */

		errno=0;
		switch(q->parameter_count)
		{
		case 1:
		{
			myfloat (*func)(myfloat );

			func=q->function;
			s[0]->num.f=func(s[0]->num.f);
			break;
		}
		case 2:
		{
			myfloat (*func)(myfloat , myfloat);

			func=q->function;
			s[0]->num.f=func(s[0]->num.f, s[1]->num.f);
			break;
		}
		}

		if(errno == EDOM)
		{
			error=ER_DOMAIN;
			return 1;
		}

		return 0;
	}

	{
		struct lex_s *prev_code;
		int prev_code_count;
		int prev_stack_frame;
		int prev_parameter_count;
		int res;

/* ݂ۑ */
		prev_code=code;
		prev_code_count=code_count;
		prev_stack_frame=stack_frame;
		prev_parameter_count=parameter_count;

/* VlZbg */
		code=p->code;
		code_count=p->code_count;
		stack_frame=stack_pointer;
		parameter_count=p->parameter_count;

		res=call_function_sub(p);

/* ɖ߂ */
		code=prev_code;
		code_count=prev_code_count;
		stack_frame=prev_stack_frame;
		parameter_count=prev_parameter_count;

		return res;
	}

}

static int call_function_sub(struct user_function_s * const p)
{
	char *q;
	struct stack_s *s;

/* ֐̎s */
	q=run_code();
	if(q != NULL)
		return 1;

	s=pop();	/* ֐̓|bv */

/* stack_pointer ɖ߂ */
	stack_pointer=stack_frame-parameter_count;
/* ֐̌ʂX^bNɐς */
	push_stack(s);

	return 0;
}

/* |              | <= sp
 * +--------------+
 * |              |
 * +--------------+
 * |  something   | <= fp
 * +--------------+
 * |last parameter(parameter_count-1)|
 * +--------------+
 * |              |
 *~~~~~~~~~~~~~~~~~~
 *~~~~~~~~~~~~~~~~~~
 * |              |
 * +--------------+
 * | parameter 1  |
 * +--------------+
 * | parameter 0  |
 * +--------------+
 */
void push_parameter(int i)
{
	int diff;

	diff=parameter_count-i;

	push_stack(stack_memory+stack_frame-diff);
}


