#ifndef UNDER_CE
#include <stdio.h>
#endif

#include <stdlib.h>
#include "lex.h"
#include "stack.h"
#include "parse.h"
#include "../libmisc/misc.h"

#define STACK_FIRST 32
#define STACK_STEP 8

static void stack_check(void);

struct stack_s *stack_memory;
int stack_pointer;
static int max_stack_pointer;

/*
#define free_stack() free(stack_memory)
void free_stack(void)
{
	free(stack_memory);
}
*/
void init_stack(void)
{
	if(max_stack_pointer != STACK_FIRST)
	{
		stack_memory=my_realloc(stack_memory, STACK_FIRST*sizeof(struct stack_s));
		max_stack_pointer=STACK_FIRST;
	}
	stack_pointer=0;
}

/* push Oɂ́Å֐ĂяoX^bNI[o[t[j~ */
static void stack_check(void)
{
	if(stack_pointer >= max_stack_pointer)
	{
		max_stack_pointer+=STACK_STEP;
		stack_memory=my_realloc(stack_memory, max_stack_pointer*sizeof(struct stack_s));
	}
}
#if 0
void virtual_push(void)
{
	stack_pointer++;
}
#endif

void push_stack(struct stack_s * const p)
{
	stack_check();
	stack_memory[stack_pointer++]=*p;
}
void push_num(int type, union num_u num)
{
	stack_check();
	stack_memory[stack_pointer].type=type;
	stack_memory[stack_pointer].num=num;
	stack_pointer++;
}

void push_float(myfloat num)
{
	stack_check();
	stack_memory[stack_pointer].type=TYPE_FLOAT;
	stack_memory[stack_pointer].num.f=num;
	stack_pointer++;
}
void push_integer(struct int_s i)
{
	stack_check();
	stack_memory[stack_pointer].type=TYPE_INTEGER;
	stack_memory[stack_pointer].num.integer=i;
	stack_pointer++;
}

struct stack_s *virtual_pop(void)
{
	if(stack_pointer == 0)
	{
		error=ER_STACK_UNDER_FLOW;
		return &stack_memory[0];/* Ƃ肠ANULL ԂĂɃANZX */
	}
	else
		return &stack_memory[stack_pointer-1];
}

struct stack_s *pop(void)
{
	if(stack_pointer == 0)
	{
		error=ER_STACK_UNDER_FLOW;
		return &stack_memory[0];	/* Ƃ肠ANULL ԂĂɃANZX */
	}
	else
		return &stack_memory[--stack_pointer];

}

