#ifndef STACK_H
#define STACK_H

#include "machine.h"
#include "lex.h"

struct stack_s{
	int type;
	union num_u num;
};

void virtual_push(void);
void push_num(int type, union num_u num);
void push_float(myfloat num);
void push_integer(struct int_s i);
void push_stack(struct stack_s * const p);

struct stack_s *pop(void);
struct stack_s *virtual_pop(void);

void init_stack(void);
#define free_stack() free(stack_memory)



extern struct stack_s *stack_memory;
extern int stack_pointer;

#endif

