#ifndef UNDER_CE
#include <stdio.h>
#endif

#include <stdlib.h>
#include <string.h>

#include "lex.h"
#include "stack.h"
#include "variable.h"
#include "../libmisc/misc.h"
#include "utility.h"
#include "machine.h"

#define HASH_NUM 16

static int get_hash(char *str);

static struct variable_s *variable[HASH_NUM];


struct variable_s *variable_get(char * const id)
{
	int index;
	struct variable_s *p;

	index=get_hash(id);
	p=variable[index];

	for(; p != NULL; p=p->next)
		if(strcmp(p->name, id) == 0)
			return p;
	return NULL;
}

void variable_set(char * const id, struct stack_s * const v)
{
	struct variable_s *p;
	int index;

	index=get_hash(id);

	p=my_malloc(sizeof(struct variable_s));

	p->next=variable[index];
	variable[index]=p;

	p->name=id;
	p->type=v->type;
	p->num=v->num;


#ifdef RUPUTER
	rup_vari_add_menu(id);
#endif

}

static int get_hash(char *str)
{
	int c=0;

	while(*str)
	{
		c^=*str++;
		c<<=1;
	}

	if(c < 0)
		return (-c)%HASH_NUM;
	else
		return c%HASH_NUM;

}


#ifdef ENABLE_VARIABLE_TO_STRING
void variable_to_string(char *str)
{
	int i;
	struct variable_s *p;


	*str=0;
	for(i=0; i < HASH_NUM; i++)
	{
		p=variable[i];

		for(; p != NULL; p=p->next)
		{
	//			sprintf(str, "%s=", p->name);
			strcpy(str, p->name);
			strcat(str, "=");
			num_to_string((struct stack_s *)p, str+strlen(str));
#if defined(WINDOWS) || defined(UNICODE)
			strcat(str, "\x0d\x0a");
#else
			strcat(str, "\n");
#endif
			str+=strlen(str);
		}
	}
}

#endif

