/*--------------------------------------------------------------------
 * dtoa (double to ascii) ֐
 * ruputer pɎgƁAfloat łB
 *
 * ́A[sign]d.ddddce... ̌`Ŋi[
 *
 *
 * 1.00 
 * 1.01 ȂύXB
 *		xŐ؂B
 *		power gȂ X 2000/2/24
 * 1.011 power gɁB
 * 1.10 SύX
 * 1.101 e[ugȂ悤ɂB́AXy[XiTCYjB
 * 1.11 ľܓǉ
 * 1.12 KɌBľܓPɁB 8/30
 * 1.13 10iw̔rɂ INF, 0 ̔fɃ}NgB
 * 1.14 oOtBbNXBl񉻂intłƎvĂB
 * 1.15 oOtBbNXBľܓ̕ӂB
 *-----------------------
 *  1/18
 *  Eultoa ʃ\[Xֈړ
 * 
 *---------------------------------------------------------------------*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#include "my_dtoa.h"
#include "myultoa.h"
/*
#define _double_IS_32BITS
typedef float double;
*/


#ifndef _DOUBLE_IS_32BITS
void my_dtoa(double d, char *str)
{
	sprintf(str, "dota ... %.20e", d);
	return;
}

#else
/* ͈ȍ~́Adouble ́A32 bits ܂ float ƓdlĂ */

static char zero[]="0.0e+0";
static char inf[]="inf";

#define SYOUSU_BIT 23
#define SYOUSU_BIT_MASK 0x7fffff
#define YOTEI_SYOUSU_BIT 0x800000
#define YUKOU_KETA 7	/* LB܂ŎcAľܓ */





#define FLOAT_BIAS 127

/* gGfBAp */
struct float_bit{
	unsigned int lsyousu : 16;
	unsigned int hsyousu : 7;
	unsigned int exp : 8;
	unsigned int sign : 1;
};
union float_union{
	double value;
	struct float_bit ieee;
	unsigned long ul_value;
};

void my_dtoa(double d, char *str)
{
	int exp10, two_exp, len;
	char buf[16];
	char *p;
	unsigned long c;
	union float_union *check;

	check=&d;

	if(check->ieee.exp == 0xff)	/* inf check */
	{
		*str=(check->ieee.sign == 1 ? '-' : '+');
		strcpy(str+1, inf);
		return;
	}
	else if((check->ul_value & 0x7fffffffUL) == 0)
	{
		strcpy(str, zero);
		return;
	}

	two_exp=(int)check->ieee.exp-FLOAT_BIAS;
	two_exp-=SYOUSU_BIT;
	exp10=0;


	c=(check->ul_value & SYOUSU_BIT_MASK) | YOTEI_SYOUSU_BIT;

	if(two_exp >= 0)
		while(two_exp--)
		{
			if(c & 1L<<31)
			{
/* 10 ŊāAQB āAexp10 CNg鏈 */
				c/=5;
				exp10++;
			}
			else
				c<<=1;
		}
	else
		while(two_exp++)
		{
			if(c <= 0xffffffffUL/5)
			{
/* POĂQŊBāAexp10 fNg */
				c*=5;
				exp10--;
			}
			else
				c>>=1;
		}


	my_ultoa(c, buf+1);	/* +1 ́Aľܓɂ錅オl */
	*buf='0';

	len=strlen(buf+1);

	if(len > YUKOU_KETA)
	{
		p=buf+1+YUKOU_KETA;

		if(*p >= '5')
		{
			++*(p-1);

			p--;

	/* オ */
			for(; *p > '9'; p--)
			{
				*p-=10;
				++*(p-1);
			}
		}
	}


	p=buf;
	if(*p == '0')
		p++;

	exp10+=strlen(p)-1;

	*(p+YUKOU_KETA)=0;

	if(exp10 < FLT_MIN_10_EXP)
	{
		strcpy(str, zero);
		return;
	}
	else if(exp10 > FLT_MAX_10_EXP)
	{
		*str=(check->ieee.sign == 1 ? '-' : '+');
		strcpy(str+1, inf);
		return;
	}


	if(check->ieee.sign == 1)
		*str++='-';

	*str++=*p++;
	*str++='.';

	while(*str=*p++)
		str++;

	*str++='e';

	if(exp10 >= 0)
		*str='+';
	else
	{
		exp10=-exp10;
		*str='-';
	}
	my_ultoa(exp10, str+1);
}
#endif /* _double_IS_32BITS */

